------------------------------------------------------------------------------
--  TM4C1294.GPIO                                                           --
------------------------------------------------------------------------------

with Interfaces;

package TM4C1294.GPIO is
   pragma Preelaborate;

   type GPIO_Pin is range 0 .. 7;

   type GPIO_Alt_Func is range 0 .. 15;

   type GPIO_Mode is (Off, Input, Output, Alt_Function, Analog);

   type GPIO_Drive is (Drive_2mA, Drive_4mA, Drive_8mA);

   procedure GPIO_Set_Mode (Port : GPIO_Port;
                            Pin  : GPIO_Pin;
                            Mode : GPIO_Mode;
                            AF   : GPIO_Alt_Func := 0);

   procedure GPIO_Set_Drive (Port  : GPIO_Port;
                             Pin   : GPIO_Pin;
                             Drive : GPIO_Drive);

   procedure GPIO_Write (Port        : GPIO_Port;
                         Value       : Interfaces.Unsigned_8;
                         Output_Mask : Interfaces.Unsigned_8 := 16#FF#);

   procedure Blink_LED1;

   procedure Blink_LED2;

private

   function Pin_Supports_Analog (Port : GPIO_Port;
                                 Pin  : GPIO_Pin) return Boolean;

   procedure Wait;

end TM4C1294.GPIO;
