-------------------------------------------------------------------------------
--  10-JUL-2015 TM4C1294 by john.caffyn@btconnect.com                        --
-------------------------------------------------------------------------------
with System;

package body TM4C1294 is

   use type Interfaces.Unsigned_32;

   procedure Enable_Port_Clocking (Port : GPIO_Port) is
      SYSCTL : System_Control_Registers with Volatile,
                  Address => System'To_Address (Sys_Ctrl_Base_Address);
      GPIOBIT : Word;
   begin

      GPIOBIT := 2**GPIO_Port'Pos (Port);
      SYSCTL.RCGCGPIO := SYSCTL.RCGCGPIO or GPIOBIT;

   end Enable_Port_Clocking;

   procedure Disable_Port_Clocking (Port : GPIO_Port) is
      SYSCTL : System_Control_Registers with Volatile,
                  Address => System'To_Address (Sys_Ctrl_Base_Address);
      GPIOBIT : Word;
   begin

      GPIOBIT := 2**GPIO_Port'Pos (Port);
      SYSCTL.RCGCGPIO := SYSCTL.RCGCGPIO and not GPIOBIT;

   end Disable_Port_Clocking;

-------------------------------------------------------------------------------
--  Enable_UART_Clocking                                                     --
-------------------------------------------------------------------------------

   procedure Enable_UART_Clocking (Port : UART_Port) is
      SYSCTL : System_Control_Registers with Volatile,
                  Address => System'To_Address (Sys_Ctrl_Base_Address);
      UARTBIT : Word;
      PRUART  : Word;
      pragma Volatile (PRUART);
   begin

      UARTBIT := 2**UART_Port'Pos (Port);
      SYSCTL.RCGCUART := SYSCTL.RCGCUART or UARTBIT;

      loop -- Wait for UART ready ...
         PRUART := SYSCTL.PRUART;
         exit when (PRUART and UARTBIT) = UARTBIT;
      end loop;

      SYSCTL.SRUART := SYSCTL.SRUART or UARTBIT;
      SYSCTL.SRUART := SYSCTL.SRUART and not UARTBIT;

      loop -- Wait for UART ready ...
         PRUART := SYSCTL.PRUART;
         exit when (PRUART and UARTBIT) = UARTBIT;
      end loop;

   end Enable_UART_Clocking;

-------------------------------------------------------------------------------
--  Disable_UART_Clocking                                                    --
-------------------------------------------------------------------------------

   procedure Disable_UART_Clocking (Port : UART_Port) is
      SYSCTL : System_Control_Registers with Volatile,
                  Address => System'To_Address (Sys_Ctrl_Base_Address);
      UARTBIT : Word;
   begin

      UARTBIT := 2**UART_Port'Pos (Port);
      SYSCTL.RCGCUART := SYSCTL.RCGCUART and not UARTBIT;

   end Disable_UART_Clocking;

end TM4C1294;