-------------------------------------------------------------------------------
--  10-JUL-2015 TM4C1294 by john.caffyn@btconnect.com                        --
-------------------------------------------------------------------------------
with Interfaces;

package TM4C1294 is
   pragma Preelaborate;

   BIT0  : constant := 16#0000_0001#;
   BIT1  : constant := 16#0000_0002#;
   BIT2  : constant := 16#0000_0004#;
   BIT3  : constant := 16#0000_0008#;
   BIT4  : constant := 16#0000_0010#;
   BIT5  : constant := 16#0000_0020#;
   BIT6  : constant := 16#0000_0040#;
   BIT7  : constant := 16#0000_0080#;
   BIT8  : constant := 16#0000_0100#;
   BIT9  : constant := 16#0000_0200#;
   BIT10 : constant := 16#0000_0400#;
   BIT11 : constant := 16#0000_0800#;
   BIT12 : constant := 16#0000_1000#;
   BIT13 : constant := 16#0000_2000#;
   BIT14 : constant := 16#0000_4000#;
   BIT15 : constant := 16#0000_8000#;
   BIT16 : constant := 16#0001_0000#;
   BIT17 : constant := 16#0002_0000#;
   BIT18 : constant := 16#0004_0000#;
   BIT19 : constant := 16#0008_0000#;
   BIT20 : constant := 16#0010_0000#;
   BIT21 : constant := 16#0020_0000#;
   BIT22 : constant := 16#0040_0000#;
   BIT23 : constant := 16#0080_0000#;
   BIT24 : constant := 16#0100_0000#;
   BIT25 : constant := 16#0200_0000#;
   BIT26 : constant := 16#0400_0000#;
   BIT27 : constant := 16#0800_0000#;
   BIT28 : constant := 16#1000_0000#;
   BIT29 : constant := 16#2000_0000#;
   BIT30 : constant := 16#4000_0000#;
   BIT31 : constant := 16#8000_0000#;

   subtype Word is Interfaces.Unsigned_32;

   type System_Control_Registers is record
      DID0        : Word;
      DID1        : Word;
      PTBOCTL     : Word;
      RIS         : Word;
      IMC         : Word;
      MISC        : Word;
      RESC        : Word;
      PWRTC       : Word;
      NMIC        : Word;
      MOSCCTL     : Word;
      RSCLKCFG    : Word;
      MEMTIM0     : Word;
      ALTCLKCFG   : Word;
      DSCLKCFG    : Word;
      DIVSCLK     : Word;
      SYSPROP     : Word;
      PIOSCCAL    : Word;
      PIOSCSTAT   : Word;
      PLLFREQ0    : Word;
      PLLFREQ1    : Word;
      PLLSTAT     : Word;
      SLPPWRCFG   : Word;
      DSLPPWRCFG  : Word;
      NVMSTAT     : Word;
      LDOSPCTL    : Word;
      LDODPCTL    : Word;
      RESBEHAVCTL : Word;
      HSSR        : Word;
      USBPDS      : Word;
      USBMPC      : Word;
      EMACPDS     : Word;
      EMACMPC     : Word;
      PPWD        : Word;
      PPTIMER     : Word;
      PPGPIO      : Word;
      PPDMA       : Word;
      PPEPI       : Word;
      PPHIB       : Word;
      PPUART      : Word;
      PPSSI       : Word;
      PPI2C       : Word;
      PPUSB       : Word;
      PPEPHY      : Word;
      PPCAN       : Word;
      PPADC       : Word;
      PPACMP      : Word;
      PPPWM       : Word;
      PPQEI       : Word;
      PPLPC       : Word;
      PPPECI      : Word;
      PPFAN       : Word;
      PPEEPROM    : Word;
      PPWTIMER    : Word;
      PPRTS       : Word;
      PPCCM       : Word;
      PPLCD       : Word;
      PPOWIRE     : Word;
      PPEMAC      : Word;
      PPHIM       : Word;
      SRWD        : Word;
      SRTIMER     : Word;
      SRGPIO      : Word;
      SRDMA       : Word;
      SREPI       : Word;
      SRHIB       : Word;
      SRUART      : Word;
      SRSSI       : Word;
      SRI2C       : Word;
      SRUSB       : Word;
      SREPHY      : Word;
      SRCAN       : Word;
      SRADC       : Word;
      SRACMP      : Word;
      SRPWM       : Word;
      SRQEI       : Word;
      SREEPROM    : Word;
      SRCCM       : Word;
      SREMAC      : Word;
      RCGCWD      : Word;
      RCGCTIMER   : Word;
      RCGCGPIO    : Word;
      RCGCDMA     : Word;
      RCGCEPI     : Word;
      RCGCHIB     : Word;
      RCGCUART    : Word;
      RCGCSSI     : Word;
      RCGCI2C     : Word;
      RCGCUSB     : Word;
      RCGCEPHY    : Word;
      RCGCCAN     : Word;
      RCGCADC     : Word;
      RCGCACMP    : Word;
      RCGCPWM     : Word;
      RCGCQEI     : Word;
      RCGCEEPROM  : Word;
      RCGCCCM     : Word;
      RCGCEMAC    : Word;
      SCGCWD      : Word;
      SCGCTIMER   : Word;
      SCGCGPIO    : Word;
      SCGCDMA     : Word;
      SCGCEPI     : Word;
      SCGCHIB     : Word;
      SCGCUART    : Word;
      SCGCSSI     : Word;
      SCGCI2C     : Word;
      SCGCUSB     : Word;
      SCGCEPHY    : Word;
      SCGCCAN     : Word;
      SCGCADC     : Word;
      SCGCACMP    : Word;
      SCGCPWM     : Word;
      SCGCQEI     : Word;
      SCGCEEPROM  : Word;
      SCGCCCM     : Word;
      SCGCEMAC    : Word;
      DCGCWD      : Word;
      DCGCTIMER   : Word;
      DCGCGPIO    : Word;
      DCGCDMA     : Word;
      DCGCEPI     : Word;
      DCGCHIB     : Word;
      DCGCUART    : Word;
      DCGCSSI     : Word;
      DCGCI2C     : Word;
      DCGCUSB     : Word;
      DCGCEPHY    : Word;
      DCGCCAN     : Word;
      DCGCADC     : Word;
      DCGCACMP    : Word;
      DCGCPWM     : Word;
      DCGCQEI     : Word;
      DCGCEEPROM  : Word;
      DCGCCCM     : Word;
      DCGCEMAC    : Word;
      PCWD        : Word;
      PCTIMER     : Word;
      PCGPIO      : Word;
      PCDMA       : Word;
      PCEPI       : Word;
      PCHIB       : Word;
      PCUART      : Word;
      PCSSI       : Word;
      PCI2C       : Word;
      PCUSB       : Word;
      PCEPHY      : Word;
      PCCAN       : Word;
      PCADC       : Word;
      PCACMP      : Word;
      PCPWM       : Word;
      PCQEI       : Word;
      PCEEPROM    : Word;
      PCCCM       : Word;
      PCEMAC      : Word;
      PRWD        : Word;
      PRTIMER     : Word;
      PRGPIO      : Word;
      PRDMA       : Word;
      PREPI       : Word;
      PRHIB       : Word;
      PRUART      : Word;
      PRSSI       : Word;
      PRI2C       : Word;
      PRUSB       : Word;
      PREPHY      : Word;
      PRCAN       : Word;
      PRADC       : Word;
      PRACMP      : Word;
      PRPWM       : Word;
      PRQEI       : Word;
      PREEPROM    : Word;
      PRCCM       : Word;
      PREMAC      : Word;
   end record;

   for System_Control_Registers use record
      DID0        at 16#000# range 0 .. 31;
      DID1        at 16#004# range 0 .. 31;
      PTBOCTL     at 16#038# range 0 .. 31;
      RIS         at 16#050# range 0 .. 31;
      IMC         at 16#054# range 0 .. 31;
      MISC        at 16#058# range 0 .. 31;
      RESC        at 16#05C# range 0 .. 31;
      PWRTC       at 16#060# range 0 .. 31;
      NMIC        at 16#064# range 0 .. 31;
      MOSCCTL     at 16#07C# range 0 .. 31;
      RSCLKCFG    at 16#0B0# range 0 .. 31;
      MEMTIM0     at 16#0C0# range 0 .. 31;
      ALTCLKCFG   at 16#138# range 0 .. 31;
      DSCLKCFG    at 16#144# range 0 .. 31;
      DIVSCLK     at 16#148# range 0 .. 31;
      SYSPROP     at 16#14C# range 0 .. 31;
      PIOSCCAL    at 16#150# range 0 .. 31;
      PIOSCSTAT   at 16#154# range 0 .. 31;
      PLLFREQ0    at 16#160# range 0 .. 31;
      PLLFREQ1    at 16#164# range 0 .. 31;
      PLLSTAT     at 16#168# range 0 .. 31;
      SLPPWRCFG   at 16#188# range 0 .. 31;
      DSLPPWRCFG  at 16#18C# range 0 .. 31;
      NVMSTAT     at 16#1A0# range 0 .. 31;
      LDOSPCTL    at 16#1B4# range 0 .. 31;
      LDODPCTL    at 16#1BC# range 0 .. 31;
      RESBEHAVCTL at 16#1D8# range 0 .. 31;
      HSSR        at 16#1F4# range 0 .. 31;
      USBPDS      at 16#280# range 0 .. 31;
      USBMPC      at 16#284# range 0 .. 31;
      EMACPDS     at 16#288# range 0 .. 31;
      EMACMPC     at 16#28C# range 0 .. 31;
      PPWD        at 16#300# range 0 .. 31;
      PPTIMER     at 16#304# range 0 .. 31;
      PPGPIO      at 16#308# range 0 .. 31;
      PPDMA       at 16#30C# range 0 .. 31;
      PPEPI       at 16#310# range 0 .. 31;
      PPHIB       at 16#314# range 0 .. 31;
      PPUART      at 16#318# range 0 .. 31;
      PPSSI       at 16#31C# range 0 .. 31;
      PPI2C       at 16#320# range 0 .. 31;
      PPUSB       at 16#328# range 0 .. 31;
      PPEPHY      at 16#330# range 0 .. 31;
      PPCAN       at 16#334# range 0 .. 31;
      PPADC       at 16#338# range 0 .. 31;
      PPACMP      at 16#33C# range 0 .. 31;
      PPPWM       at 16#340# range 0 .. 31;
      PPQEI       at 16#344# range 0 .. 31;
      PPLPC       at 16#348# range 0 .. 31;
      PPPECI      at 16#350# range 0 .. 31;
      PPFAN       at 16#354# range 0 .. 31;
      PPEEPROM    at 16#358# range 0 .. 31;
      PPWTIMER    at 16#35C# range 0 .. 31;
      PPRTS       at 16#370# range 0 .. 31;
      PPCCM       at 16#374# range 0 .. 31;
      PPLCD       at 16#390# range 0 .. 31;
      PPOWIRE     at 16#398# range 0 .. 31;
      PPEMAC      at 16#39C# range 0 .. 31;
      PPHIM       at 16#3A4# range 0 .. 31;
      SRWD        at 16#500# range 0 .. 31;
      SRTIMER     at 16#504# range 0 .. 31;
      SRGPIO      at 16#508# range 0 .. 31;
      SRDMA       at 16#50C# range 0 .. 31;
      SREPI       at 16#510# range 0 .. 31;
      SRHIB       at 16#514# range 0 .. 31;
      SRUART      at 16#518# range 0 .. 31;
      SRSSI       at 16#51C# range 0 .. 31;
      SRI2C       at 16#520# range 0 .. 31;
      SRUSB       at 16#528# range 0 .. 31;
      SREPHY      at 16#530# range 0 .. 31;
      SRCAN       at 16#534# range 0 .. 31;
      SRADC       at 16#538# range 0 .. 31;
      SRACMP      at 16#53C# range 0 .. 31;
      SRPWM       at 16#540# range 0 .. 31;
      SRQEI       at 16#544# range 0 .. 31;
      SREEPROM    at 16#558# range 0 .. 31;
      SRCCM       at 16#574# range 0 .. 31;
      SREMAC      at 16#59C# range 0 .. 31;
      RCGCWD      at 16#600# range 0 .. 31;
      RCGCTIMER   at 16#604# range 0 .. 31;
      RCGCGPIO    at 16#608# range 0 .. 31;
      RCGCDMA     at 16#60C# range 0 .. 31;
      RCGCEPI     at 16#610# range 0 .. 31;
      RCGCHIB     at 16#614# range 0 .. 31;
      RCGCUART    at 16#618# range 0 .. 31;
      RCGCSSI     at 16#61C# range 0 .. 31;
      RCGCI2C     at 16#620# range 0 .. 31;
      RCGCUSB     at 16#628# range 0 .. 31;
      RCGCEPHY    at 16#630# range 0 .. 31;
      RCGCCAN     at 16#634# range 0 .. 31;
      RCGCADC     at 16#638# range 0 .. 31;
      RCGCACMP    at 16#63C# range 0 .. 31;
      RCGCPWM     at 16#640# range 0 .. 31;
      RCGCQEI     at 16#644# range 0 .. 31;
      RCGCEEPROM  at 16#658# range 0 .. 31;
      RCGCCCM     at 16#674# range 0 .. 31;
      RCGCEMAC    at 16#69C# range 0 .. 31;
      SCGCWD      at 16#700# range 0 .. 31;
      SCGCTIMER   at 16#704# range 0 .. 31;
      SCGCGPIO    at 16#708# range 0 .. 31;
      SCGCDMA     at 16#70C# range 0 .. 31;
      SCGCEPI     at 16#710# range 0 .. 31;
      SCGCHIB     at 16#714# range 0 .. 31;
      SCGCUART    at 16#718# range 0 .. 31;
      SCGCSSI     at 16#71C# range 0 .. 31;
      SCGCI2C     at 16#720# range 0 .. 31;
      SCGCUSB     at 16#728# range 0 .. 31;
      SCGCEPHY    at 16#730# range 0 .. 31;
      SCGCCAN     at 16#734# range 0 .. 31;
      SCGCADC     at 16#738# range 0 .. 31;
      SCGCACMP    at 16#73C# range 0 .. 31;
      SCGCPWM     at 16#740# range 0 .. 31;
      SCGCQEI     at 16#744# range 0 .. 31;
      SCGCEEPROM  at 16#758# range 0 .. 31;
      SCGCCCM     at 16#774# range 0 .. 31;
      SCGCEMAC    at 16#79C# range 0 .. 31;
      DCGCWD      at 16#800# range 0 .. 31;
      DCGCTIMER   at 16#804# range 0 .. 31;
      DCGCGPIO    at 16#808# range 0 .. 31;
      DCGCDMA     at 16#80C# range 0 .. 31;
      DCGCEPI     at 16#810# range 0 .. 31;
      DCGCHIB     at 16#814# range 0 .. 31;
      DCGCUART    at 16#818# range 0 .. 31;
      DCGCSSI     at 16#81C# range 0 .. 31;
      DCGCI2C     at 16#820# range 0 .. 31;
      DCGCUSB     at 16#828# range 0 .. 31;
      DCGCEPHY    at 16#830# range 0 .. 31;
      DCGCCAN     at 16#834# range 0 .. 31;
      DCGCADC     at 16#838# range 0 .. 31;
      DCGCACMP    at 16#83C# range 0 .. 31;
      DCGCPWM     at 16#840# range 0 .. 31;
      DCGCQEI     at 16#844# range 0 .. 31;
      DCGCEEPROM  at 16#858# range 0 .. 31;
      DCGCCCM     at 16#874# range 0 .. 31;
      DCGCEMAC    at 16#89C# range 0 .. 31;
      PCWD        at 16#900# range 0 .. 31;
      PCTIMER     at 16#904# range 0 .. 31;
      PCGPIO      at 16#908# range 0 .. 31;
      PCDMA       at 16#90C# range 0 .. 31;
      PCEPI       at 16#910# range 0 .. 31;
      PCHIB       at 16#914# range 0 .. 31;
      PCUART      at 16#918# range 0 .. 31;
      PCSSI       at 16#91C# range 0 .. 31;
      PCI2C       at 16#920# range 0 .. 31;
      PCUSB       at 16#928# range 0 .. 31;
      PCEPHY      at 16#930# range 0 .. 31;
      PCCAN       at 16#934# range 0 .. 31;
      PCADC       at 16#938# range 0 .. 31;
      PCACMP      at 16#93C# range 0 .. 31;
      PCPWM       at 16#940# range 0 .. 31;
      PCQEI       at 16#944# range 0 .. 31;
      PCEEPROM    at 16#958# range 0 .. 31;
      PCCCM       at 16#974# range 0 .. 31;
      PCEMAC      at 16#99C# range 0 .. 31;
      PRWD        at 16#A00# range 0 .. 31;
      PRTIMER     at 16#A04# range 0 .. 31;
      PRGPIO      at 16#A08# range 0 .. 31;
      PRDMA       at 16#A0C# range 0 .. 31;
      PREPI       at 16#A10# range 0 .. 31;
      PRHIB       at 16#A14# range 0 .. 31;
      PRUART      at 16#A18# range 0 .. 31;
      PRSSI       at 16#A1C# range 0 .. 31;
      PRI2C       at 16#A20# range 0 .. 31;
      PRUSB       at 16#A28# range 0 .. 31;
      PREPHY      at 16#A30# range 0 .. 31;
      PRCAN       at 16#A34# range 0 .. 31;
      PRADC       at 16#A38# range 0 .. 31;
      PRACMP      at 16#A3C# range 0 .. 31;
      PRPWM       at 16#A40# range 0 .. 31;
      PRQEI       at 16#A44# range 0 .. 31;
      PREEPROM    at 16#A58# range 0 .. 31;
      PRCCM       at 16#A74# range 0 .. 31;
      PREMAC      at 16#A9C# range 0 .. 31;
   end record;

   Sys_Ctrl_Base_Address : constant := 16#400F_E000#;

   UART0_Base_Address : constant := 16#4000_C000#;
   UART1_Base_Address : constant := 16#4000_D000#;
   UART2_Base_Address : constant := 16#4000_E000#;
   UART3_Base_Address : constant := 16#4000_F000#;
   UART4_Base_Address : constant := 16#4001_0000#;
   UART5_Base_Address : constant := 16#4001_1000#;
   UART6_Base_Address : constant := 16#4001_2000#;
   UART7_Base_Address : constant := 16#4001_3000#;

   SSI0_Base_Address : constant := 16#4000_8000#;
   SSI1_Base_Address : constant := 16#4000_9000#;
   SSI2_Base_Address : constant := 16#4000_A000#;
   SSI3_Base_Address : constant := 16#4000_B000#;

   I2C0_Base_Address : constant := 16#4002_0000#;
   I2C1_Base_Address : constant := 16#4002_1000#;
   I2C2_Base_Address : constant := 16#4002_2000#;
   I2C3_Base_Address : constant := 16#4002_3000#;
   I2C4_Base_Address : constant := 16#400C_0000#;
   I2C5_Base_Address : constant := 16#400C_1000#;
   I2C6_Base_Address : constant := 16#400C_2000#;
   I2C7_Base_Address : constant := 16#400C_3000#;
   I2C8_Base_Address : constant := 16#400B_8000#;
   I2C9_Base_Address : constant := 16#400B_9000#;

   TIMER0_Base_Address : constant := 16#4003_0000#;
   TIMER1_Base_Address : constant := 16#4003_1000#;
   TIMER2_Base_Address : constant := 16#4003_2000#;
   TIMER3_Base_Address : constant := 16#4003_3000#;
   TIMER4_Base_Address : constant := 16#4003_4000#;
   TIMER5_Base_Address : constant := 16#4003_5000#;
   TIMER6_Base_Address : constant := 16#400E_0000#;
   TIMER7_Base_Address : constant := 16#400E_1000#;

   ADC0_Base_Address : constant := 16#4003_8000#;
   ADC1_Base_Address : constant := 16#4003_9000#;

   EMAC0_Base_Address : constant := 16#400E_C000#;

   CAN0_Base_Address : constant := 16#4004_0000#;
   CAN1_Base_Address : constant := 16#4004_1000#;

   GPIO_PORTA_Base_Address : constant := 16#4005_8000#;
   GPIO_PORTB_Base_Address : constant := 16#4005_9000#;
   GPIO_PORTC_Base_Address : constant := 16#4005_A000#;
   GPIO_PORTD_Base_Address : constant := 16#4005_B000#;
   GPIO_PORTE_Base_Address : constant := 16#4005_C000#;
   GPIO_PORTF_Base_Address : constant := 16#4005_D000#;
   GPIO_PORTG_Base_Address : constant := 16#4005_E000#;
   GPIO_PORTH_Base_Address : constant := 16#4005_F000#;
   GPIO_PORTJ_Base_Address : constant := 16#4006_0000#;
   GPIO_PORTK_Base_Address : constant := 16#4006_1000#;
   GPIO_PORTL_Base_Address : constant := 16#4006_2000#;
   GPIO_PORTM_Base_Address : constant := 16#4006_3000#;
   GPIO_PORTN_Base_Address : constant := 16#4006_4000#;
   GPIO_PORTP_Base_Address : constant := 16#4006_5000#;
   GPIO_PORTQ_Base_Address : constant := 16#4006_6000#;

   type GPIO_Port is (PortA, PortB, PortC, PortD, PortE, PortF, PortG, PortH,
                      PortJ, PortK, PortL, PortM, PortN, PortP, PortQ);

   type UART_Port is (UART0, UART1, UART2, UART3, UART4, UART5, UART6, UART7);

   type I2C_Port is (I2C0, I2C1, I2C2, I2C3, I2C4, I2C5, I2C6, I2C7,
                     I2C8, I2C9);

   procedure Enable_Port_Clocking (Port : GPIO_Port);

   procedure Disable_Port_Clocking (Port : GPIO_Port);

   procedure Enable_UART_Clocking (Port : UART_Port);

   procedure Disable_UART_Clocking (Port : UART_Port);

end TM4C1294;